create or replace table FAQ400.SUITS (sname varchar(20) not null with default,
    constraint SUITS_PK primary key (sname)
);
insert into FAQ400.SUITS (sname) values 
 ('Hearts')
,('Diamonds')
,('Clubs')
,('Spades')
;
stop;

create or replace table FAQ400.RANKS (rname varchar(20) not null with default,
    constraint RANKS_PK primary key (rname)
);

insert into FAQ400.RANKS (rname) values 
 ('A'),('2'),('3'),('4'),('5')
,('6'),('7'),('8'),('9'),('10')
,('J'),('Q'),('K')
;
stop;
select * from FAQ400.RANKS, FAQ400.SUITS ;
select * from FAQ400.RANKS cross join FAQ400.SUITS ;
select * from FAQ400.RANKS inner join FAQ400.SUITS on 1=1;




create or replace table FAQ400.CUSTVALUES (
     Cliente varchar(20) not null with default
    ,Anno    decimal(4, 0) not null with default
    ,VGen    decimal(7, 0) not null with default
    ,VFeb    decimal(7, 0) not null with default
    ,VMar    decimal(7, 0) not null with default
    ,VApr    decimal(7, 0) not null with default
    ,VMag    decimal(7, 0) not null with default
    ,VGiu    decimal(7, 0) not null with default
    ,VLug    decimal(7, 0) not null with default
    ,VAgo    decimal(7, 0) not null with default
    ,VSet    decimal(7, 0) not null with default
    ,VOtt    decimal(7, 0) not null with default
    ,VNov    decimal(7, 0) not null with default
    ,VDic    decimal(7, 0) not null with default
                
    ,constraint CUSTVALUES_PK primary key (Cliente,  Anno)
);

insert into FAQ400.CUSTVALUES (Cliente, anno, Vgen, VFeb, VMar, VApr, VMag, VGiu
                                , VLug, VAgo, VSet, VOtt, VNov, VDic) values 
  ('Rossi', 2018, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21)
 ,('Rossi', 2019, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31)
 ,('Verdi', 2018, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41)

;
stop;


create view FAQ400.CUSTV_V1 (Cliente, Anno, Mese, Valore) as 

select Cliente, anno, cast(1  as decimal(2, 0)) as mese, VGen as Valore from FAQ400.CUSTVALUES union
select Cliente, anno, cast(2  as decimal(2, 0)) as mese, VFeb as Valore from FAQ400.CUSTVALUES union
select Cliente, anno, cast(3  as decimal(2, 0)) as mese, VMar as Valore from FAQ400.CUSTVALUES union
select Cliente, anno, cast(4  as decimal(2, 0)) as mese, VApr as Valore from FAQ400.CUSTVALUES union
select Cliente, anno, cast(5  as decimal(2, 0)) as mese, VMag as Valore from FAQ400.CUSTVALUES union
select Cliente, anno, cast(6  as decimal(2, 0)) as mese, VGiu as Valore from FAQ400.CUSTVALUES union
select Cliente, anno, cast(7  as decimal(2, 0)) as mese, VLug as Valore from FAQ400.CUSTVALUES union
select Cliente, anno, cast(8  as decimal(2, 0)) as mese, VAgo as Valore from FAQ400.CUSTVALUES union
select Cliente, anno, cast(9  as decimal(2, 0)) as mese, VSet as Valore from FAQ400.CUSTVALUES union
select Cliente, anno, cast(10 as decimal(2, 0)) as mese, VOtt as Valore from FAQ400.CUSTVALUES union
select Cliente, anno, cast(11 as decimal(2, 0)) as mese, VNov as Valore from FAQ400.CUSTVALUES union
select Cliente, anno, cast(12 as decimal(2, 0)) as mese, VDic as Valore from FAQ400.CUSTVALUES

; 
select * from FAQ400.CUSTV_V1 order by 1, 2, 3






CREATE TABLE FAQ400.MESI (MESE DECIMAL (2 , 0) NOT NULL WITH DEFAULT,
CONSTRAINT MESI_PK PRIMARY KEY (MESE), CONSTRAINT MESI_CHECK CHECK   
(mese >= 1 and mese <=12 ))                                       
;

INSERT INTO FAQ400.MESI VALUES
(1), (2), (3), (4), (5), (6)
, (7), (8), (9), (10), (11), (12)
;

select * from FAQ400.MESI;




create view FAQ400.CUSTV_V2 (Cliente, Anno, Mese, Valore) as 
select cliente, anno, mese,                         
case mese                                         
when 1  then Vgen                                
when 2  then Vfeb                                
when 3  then Vmar                                
when 4  then Vapr                                
when 5  then Vmag                                 
when 6  then Vgiu                                
when 7  then Vlug                                
when 8  then Vago                                
when 9  then Vset                                
when 10 then Vott                                
when 11 then Vnov                                
when 12 then Vdic                                
end as Valore                                   
from FAQ400.CUSTVALUES 

cross join cross join
 (VALUES(1), (2), (3), (4), (5), (6), (7), (8),
(9), (10), (11), (12)) as T2(mese)  
;


create or replace view FAQ400.CUSTV_V3 (Cliente, Anno, Mese, Valore) as 
select cliente, anno, mese,                         
case mese                                         
when 1  then Vgen                                
when 2  then Vfeb                                
when 3  then Vmar                                
when 4  then Vapr                                
when 5  then Vmag                                 
when 6  then Vgiu                                
when 7  then Vlug                                
when 8  then Vago                                
when 9  then Vset                                
when 10 then Vott                                
when 11 then Vnov                                
when 12 then Vdic                                
end as Valore                                   
from FAQ400.CUSTVALUES 
cross join 
 (  Select level as mese
From sysibm.sysdummy1
Connect by level <=12
) 
        as MESI(mese)  
;
